"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.raw = void 0;
const schema_utils_1 = require("schema-utils");
const sharp_1 = __importDefault(require("sharp"));
const webpack_loader_util_1 = require("@calvin-l/webpack-loader-util");
const options_json_1 = __importDefault(require("./options.json"));
exports.raw = true;
function default_1(content) {
    const callback = this.async();
    const options = webpack_loader_util_1.getOptions(this, true, true);
    schema_utils_1.validate(options_json_1.default, options, {
        name: "Image Rotate Loader",
        baseDataPath: "options",
    });
    processImage(content, options)
        .then((result) => {
        callback(null, result);
    })
        .catch((e) => {
        throw e;
    });
}
exports.default = default_1;
async function processImage(content, { background, angle }) {
    let sharpImage = sharp_1.default(Buffer.from(content));
    if (background)
        sharpImage = sharpImage.rotate(angle, { background });
    else
        sharpImage = sharpImage.rotate(angle);
    return await sharpImage.toBuffer();
}
//# sourceMappingURL=index.js.map